static char rcs_id[] =
    "$Id: debug.c,v 1.5 2002/05/18 20:03:53 ventox Exp $";

/* ---------------------------------------------------------------- 
 *  DConnect Daemon for Linux
 * 
 *      #(@) Copyright (c) 2002, DConnect development team
 *      #(@) Homepage: http://www.dconnect.ds.pg.gda.pl
 *
 *  This  program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License as
 *  published by the Free Software Foundation; either version 2 of
 *  the License.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY  or  FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU General Public License for more details.
 *
 *  You  should  have  received a copy  of  the GNU General Public
 *  License  along  with  this  program;  if  not,  write  to  the
 *  Free  Software  Foundation,  Inc.,  675  Mass  Ave,  Cambridge,
 *  MA 02139, USA. 
 *
 * ---------------------------------------------------------------- */

//entire file
#if defined( _DEBUG ) 

/* 
 * $Log: debug.c,v $
 * Revision 1.5  2002/05/18 20:03:53  ventox
 * - some errors corrected
 *
 * Revision 1.4  2002/04/27 18:21:10  ventox
 * Initial revision
 *
 */

#if defined( WIN32 )
#include <crtdbg.h>
#endif /* WIN32 */

// include for PCH file
#include "pch.h"

/*// include local header files
#include "module.h"*/

static char g_module_name[] = "f**k@u";

_vXhz_CONST char * _vmodule__get_name()
  { return g_module_name; }

#undef THIS_FILE
static char THIS_FILE[] = __FILE__;

/***********************************************************************/
/* function:                                                           */
/*   BOOL _vdebug_report( _vXhz_CONST char * file_name, int line )     */
/* arguments:                                                          */
/*   file_name - the          */
/*         specification fields description for details)               */ 
/* description:                                                        */
/*   functions sends a formated string to the debuger. if there's no   */
/*   system debugger the output is redirected to the stderr stream     */
/*   or any other specyfied by function _vdebug_set_outstream function */ 
/***********************************************************************/
BOOL _vdebug_report( _vXhz_CONST char * file_name, int line )
{
#if defined( WIN32 ) && !defined( _DEBUG_CNSL )
  // simply using Microsoft C Run-Time Library debugging support
  MSG  msg;
  BOOL bQuit, bRslt;

  bQuit = PeekMessage( &msg, NULL, WM_QUIT, WM_QUIT, PM_REMOVE );
  bRslt = _CrtDbgReport( _CRT_ASSERT, file_name, line, NULL, NULL );

  if ( bQuit )
    PostQuitMessage( msg.wParam );

  return bRslt;

#else /* WIN32 */ 
  char buffer[4096];
	
  sprintf( buffer, "%s\n\nFile: %s\nLine: %d", 
    _vmodule__get_name(), file_name, line );

  _vdebug_output_string( "\nAssertion Failed: " \
    "%s\n\nAbnormal program termination...\n", buffer ); 

  return TRUE;
#endif /* !WIN32 */
}

/***********************************************************************/
/* function:                                                           */
/*   void _vdebug_output_string( _vXhz_CONST char * fmt, ... )         */
/* arguments:                                                          */
/*   fmt - format control string (see printf function's format         */
/*         specification fields description for details)               */ 
/* description:                                                        */
/*   functions sends a formated string to the debuger. if there's no   */
/*   system debugger the output is redirected to the stderr stream     */
/*   or any other specyfied by function _vdebug_set_outstream function */ 
/***********************************************************************/
void _vdebug_output_string( _vXhz_CONST char * fmt, ... )
{
#if defined( WIN32 ) && !defined( _DEBUG_CNSL )
  char * buffer;
#endif /* WIN32 && !_NO_DEBUG_CNSL */

  va_list vl;

#if defined( WIN32 )
  va_start( vl, fmt );  
#else /* WIN32 */
  va_start( vl, fmt );
#endif /* !WIN32 */

#if defined( WIN32 ) && !defined( _DEBUG_CNSL ) 
  
  buffer = (char *)malloc( 4096 + 
    sizeof( char ) * strlen( fmt ) );

  vsprintf( buffer, fmt, vl );
  OutputDebugString( (LPCTSTR)buffer );

  free( buffer );

#else /* WIN32 */

  vfprintf( stderr, fmt, vl );
  fflush( stderr );

#endif /* !WIN32 */ 
  
  va_end( vl );
}

#endif /* _DEBUG */