// $Id: error.h,v 1.6 2002/05/18 20:03:53 ventox Exp $

/* ---------------------------------------------------------------- 
 *  DConnect Daemon for Linux
 * 
 *      #(@) Copyright (c) 2002, DConnect development team
 *      #(@) Homepage: http://www.dconnect.ds.pg.gda.pl
 *
 *  This  program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License as
 *  published by the Free Software Foundation; either version 2 of
 *  the License.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY  or  FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU General Public License for more details.
 *
 *  You  should  have  received a copy  of  the GNU General Public
 *  License  along  with  this  program;  if  not,  write  to  the
 *  Free  Software  Foundation,  Inc.,  675  Mass  Ave,  Cambridge,
 *  MA 02139, USA. 
 *
 * ---------------------------------------------------------------- */

/* 
 * $Log: error.h,v $
 * Revision 1.6  2002/05/18 20:03:53  ventox
 * - some errors corrected
 *
 * Revision 1.1  2002/04/27 18:21:10  ventox
 * Initial revision
 *
 */

#if !defined( __vXhz__ERROR_H__INCLUDED__ )
#define __vXhz__ERROR_H__INCLUDED__

typedef enum 
  {
    OK = 0,
    invalid_error_code,          /* special code: *DO NOT* modify it */
    
    out_of_memory,
    time_out,
    resource_exhausted,
    init_failed,
        
#if defined( _DEBUG )     
    memory_leaks_detected,
#endif /* _DEBUG */

    invalid_argument,    
    invalid_thread_proc,

    /* the number of declared error codes */
    error_codes_count 
  } 
  _status_t;

#if defined( __cplusplus )
extern "c" {
#endif /* __cplusplus */

/************************************************************************************/
/* function:                                                                        */
/*   status_t err_get_last_code( _hub_context * hub_cntx );                         */
/* arguments:                                                                       */
/*   hub_cntx - pointer to the hub context structure                                */
/* returns:                                                                         */
/*   the error code of the last operation. if no error occured the OK code will be  */
/*   given.                                                                         */
/* description:                                                                     */
/*   this function returns the error code of the last operation only. it doesn't    */
/*   remove any information about the error from hub context structure (if you need */
/*   do so, use 'err_reset_state()' function instead.                               */
/************************************************************************************/

/* couldn't compile with this - rawsock */

//status_t _vXhz_LIB_ENTRY__ err_get_last_code( void );    
  
/************************************************************************************/
/* function:                                                                        */
/*   _vXhz_CONTS char * err_get_message( status_t error_code );                   */
/* arguments:                                                                       */
/*   error_code - error code returned by the library function call                  */
/* returns:                                                                         */
/*   pointer to the const string (you cannot modify it, becouse some compilers pla- */
/*   ce it in the non-writable code segment)                                        */
/* description:                                                                     */
/*   function returns apprioprate error message, telling what has happend. it never */
/*   returns null pointer, even if the error code is invalid. in that case you will */
/*   recieve "undefined error code" message.                                        */
/************************************************************************************/

/* couldn't compile with this - rawsock */

//_vXhz_CONST char * _vXhz_LIB_ENTRY__ err_get_message( status_t );

#if defined( __cplusplus )
}  
#endif /* __cplusplus */
  
#endif /* __vXhz__ERROR_H__INCLUDED__ */