static char rcs_id[] =
	"$Id: net.c,v 1.7 2002/05/28 18:40:19 sebo Exp $";

/* ---------------------------------------------------------------- 
 *  DirectConnect HUB for Linux
 * 
 *      #(@) Copyright (c) 2002, DConnect development team
 *      #(@) Homepage: ???
 *
 *  This  program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License as
 *  published by the Free Software Foundation; either version 2 of
 *  the License.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY  or  FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU General Public License for more details.
 *
 *  You  should  have  received a copy  of  the GNU General Public
 *  License  along  with  this  program;  if  not,  write  to  the
 *  Free  Software  Foundation,  Inc.,  675  Mass  Ave,  Cambridge,
 *  MA 02139, USA. 
 *
 * error.c: interface for handling errors from library functions
 * ---------------------------------------------------------------- */

// include for PCH file
#include "pch.h"

/* 
 * $Log: net.c,v $
 * Revision 1.7  2002/05/28 18:40:19  sebo
 * Simple config file parser and minimum share requirements.
 * Please view the changes and test it.
 *
 * Revision 1.6  2002/04/27 18:21:10  ventox
 * Initial revision
 *
 *
 */

// include local header files
#include "main.h"

extern struct userrec *user[];
extern int NUSERS;

// send to single user
int send_to( struct userrec * usr, char * str )
{
  printf( "->[%s] %s\n", *(usr->nick) ? usr->nick : "Unknown", str ); 
  fflush( stdout );
 
  strcat( str, "|" );
  return send( usr->sock, str,strlen( str ), 0 );
}

// send multicast
int send_mcast( char *str )
{
  int n;
  
  printf( "->[*] %s\n", str ); 
  fflush( stdout );
  
  strcat( str, "|" );
  for ( n = 0; n < NUSERS; n++ ) 
    send( user[n]->sock, str, strlen( str ), 0 );
   
  return 0;
}

// something like printf(), but to a socket - one destination
int sendf_to( struct userrec * usr, char * format, ... )
{
  char str[1024];
  va_list args;
  
  va_start( args, format );
  vsprintf( str, format, args );
  va_end( args );

  printf( "->[%s] %s\n", *(usr->nick) ? usr->nick : "Unknown", str ); 
  fflush(stdout);
  
  strcat(str,"|");
  return send( usr->sock, str, strlen( str ), 0 );
}

// formated send - multicast
int sendf_mcast( char * format, ...) 
{
  int n;
  char str[1024];
  va_list args;

  va_start( args, format );
 
  vsprintf( str, format, args );
  va_end( args );
 
  printf( "->[*] %s\n", str ); 
  fflush( stdout );
 
  strcat( str, "|" );
  for ( n = 0; n < NUSERS; n++ ) 
    send( user[n]->sock, str, strlen( str ), 0 );
  
  return 0;
}

// this is required, since after disconnect a socket is switched to a TIME_WAIT
// state and the listening port remains occupied for several minutes
int setsockopts(int *sock)
{
 int flag=1,ret=1;
 struct linger linger;
 linger.l_onoff=0; linger.l_linger=0;
 if (setsockopt(*sock,SOL_SOCKET,SO_REUSEADDR,&flag,sizeof(flag))<0) ret=0;
 if (setsockopt(*sock,SOL_SOCKET,SO_LINGER,&linger,sizeof(linger))<0) ret=0;
 if (setsockopt(*sock,SOL_SOCKET,SO_KEEPALIVE,&flag,sizeof(flag))<0) ret=0;
 return ret;
}

// send message to public chat window
void publicmsg(char *from,struct userrec *to,char *msg)
{
 char who[20];
 if (from) strcpy(who,from); else strcpy(who,"Hub-Security");
 if (to) sendf_to(to,"<%s> %s",who,msg);
 else sendf_mcast("<%s> %s",who,msg);
}

// send message to private chat
void privmsg(char *from,struct userrec *to,char *msg)
{
 if (!to) return;
 if (from) sendf_to(to,"$To: %s From: %s $<%s> %s",to->nick,from,from,msg);
 else sendf_to(to,"$To: %s From: Hub $<Hub> %s",to->nick,msg);
}

// disconnect a user with optional reason message
void disconnect(struct userrec *usr,char *reason)
{
 if (reason) publicmsg(NULL,usr,reason);
 close(usr->sock);
 printf("Disconnected %s",*(usr->nick)?usr->nick:"Unknown");
 if (reason) printf(": %s\n",reason); else printf(".\n");
 free(usr);
}
