// $Id: queue.h,v 1.2 2002/05/28 18:40:19 sebo Exp $

/* ---------------------------------------------------------------- 
 *  DConnect Daemon for Linux
 * 
 *      #(@) Copyright (c) 2002, DConnect development team
 *      #(@) Homepage: http://www.dconnect.ds.pg.gda.pl
 *
 *  This  program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License as
 *  published by the Free Software Foundation; either version 2 of
 *  the License.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY  or  FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU General Public License for more details.
 *
 *  You  should  have  received a copy  of  the GNU General Public
 *  License  along  with  this  program;  if  not,  write  to  the
 *  Free  Software  Foundation,  Inc.,  675  Mass  Ave,  Cambridge,
 *  MA 02139, USA. 
 *
 * ---------------------------------------------------------------- */

#if !defined( _vXhz__QUEUE_H__INCLUDED__ )
#define _vXhz__QUEUE_H__INCLUDED__

/*
 * $Log: queue.h,v $
 * Revision 1.2  2002/05/28 18:40:19  sebo
 * Simple config file parser and minimum share requirements.
 * Please view the changes and test it.
 *
 * Revision 1.1  2002/05/18 23:28:24  ventox
 * - initial revision
 *
 */

// queue item
typedef struct _tagQUEUE_ITEM 
  {
    struct _tagQUEUE_ITEM * _next;
    void * _item;
  }
  _vqueue_item, * _vqueue_item_t;

// queue
typedef struct _tagQUEUE 
  {
    _vqueue_item_t _head;
    _vmutex_t      _mutex;
    _vqueue_item_t _tail;    
  }
  _vqueue, * _vqueue_t;

// function creates and initializes a queue object
//_vXhz_LIB_ENTRY _status_t _vqueue_init( _vqueue_t * _queue );

typedef void (* _vqueue_cleanup_t)( void * );

// function cleans up and destroys the specyfied queue object
//_vXhz_LIB_ENTRY _status_t _vqueue_destroy( _vqueue_t * _queue, _vqueue_cleanup_t _cleanup );

#define _vqueue_DESTROY( _queue ) \
  _vqueue_destroy( (_vqueue_t *)&(_queue), NULL )

#define _vqueue_DESTROY_AND_CLEANUP( _queue, _cleanup ) \
  _vqueue_destroy( (_vqueue_t *)&(_queue), (_vqueue_cleanup_t)(_proc) )

// function returns the first element in the specyfied queue. 
// the element will be removed without setting free the allocated memory.
//_vXhz_LIB_ENTRY void * _vqueue_pop( _vqueue_t * _queue );

#define _vqueue_POP( _queue ) \
  _vqueue_pop( (_vqueue_t *)&(_queue) )

// function returns the first element in the specyfied queue.
// the element will remained untouched in the queue.
//_vXhz_LIB_ENTRY void * _vqueue_peek( _vqueue_t * _queue );

#define _vqueue_PEEK( _queue ) \
  _vqueue_peek( (_vqueue_t *)&(_queue) )

// function removes all the elements from the specyfied queue
//_vXhz_LIB_ENTRY _status_t _vqueue_clear( _vqueue_t * _queue, _vqueue_cleanup_t _cleanup );

#define _vqueue_CLEAR( _queue ) \
  _vqueue_clear( (_vqueue_t *)&(_queue), NULL )

#define _vqueue_CLEANUP( _queue, _proc ) \
  _vqueue_clear( (_vqueue_t *)&(_queue), (_vqueue_cleanup_t)(_cleanup) )

// function puts an element in the end of the specyfied queue
//_vXhz_LIB_ENTRY _status_t _vqueue_put( _vqueue_t * _queue, void * _item );

#define _vqueue_PUT( _queue, _item ) \
  _vqueue_put( (_vqueue_t *)&(_queue), (void *)(_item) )

// funtions returns TRUE if the specyfied queue is empty
//_vXhz_LIB_ENTRY BOOL _vqueue_is_empty( _vqueue_t * _queue );

#define _vqueue_IS_EMPTY( _queue ) \
  _vqueue_is_empty( (_vqueue_t *)&(_queue) )

#endif /* _vXhz__QUEUE_H__INCLUDED__ */